//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <memory>
#include "OptPlugin.h"
#include "PropertiesForm.h"

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	return 1;
}

class TBuilderPlugin : public OptimusMiniPlugin
{
	// our plug-in is static, thus we paint only on activation and properties change
	bool m_bPaintRequired;

	TColor m_Color;

public:

	TBuilderPlugin( int function )
	{
		m_Color = clWhite;
	}

	BOOL __stdcall Paint(HDC hdc)
	{
		if (m_bPaintRequired)
		{
			std::auto_ptr<TCanvas> pCanvas(new TCanvas());

			pCanvas->Handle = hdc;
			pCanvas->Pen->Color = m_Color;
			pCanvas->Brush->Color = m_Color;

			pCanvas->Rectangle(0, 0, IMG_X_SIZE, IMG_Y_SIZE);

			m_bPaintRequired = false;
			return TRUE;
		}

		return FALSE;
	}

	void __stdcall OnKeyDown()
	{
		// some action
		::Beep(1000,100);
	}

	LPARAM __stdcall GetInfo(int index)
	{
		GET_INFO( INFO_KEY, "bcb.example.vcl" );
		GET_INFO( INFO_NAME, "BCB Example" );
		GET_INFO( INFO_DESC, "My first Borland C++ plug-in example" );

		GET_INFO( INFO_AUTHOR, "Author Name" );
		GET_INFO( INFO_EMAIL, "author@email.com" );
		GET_INFO( INFO_HOMEPAGE, "http://author.url.com" );

		GET_INFO( INFO_HAS_PROPERTIES, 1 );
		GET_IMAGE( INFO_DEFIMAGE, "IDB_DEFIMAGE" );
		GET_ICON_EX( "BIG_ICON" );
		
		return 0;
	}

	BOOL __stdcall GetProperty(int index, char *name, char *value)
	{
		GET_INT_PROPERTY(0, "Color", m_Color);

		return FALSE;
	}

	BOOL __stdcall SetProperty(const char *name, const char *value)
	{
		SET_INT_PROPERTY("Color", (int)m_Color);

		return FALSE;
	}

	BOOL __stdcall ShowProperties(HWND hwnd)
	{
		std::auto_ptr<TPropertiesForm> pForm(new TPropertiesForm((TComponent*)NULL));
		pForm->SetColor(m_Color);

		if (pForm->ShowModal() == mrOk)
		{
			m_Color = pForm->GetColor();
			m_bPaintRequired = true;
			return TRUE;
		}

		return FALSE;
	}

	BOOL __stdcall OnEvent(int event)
	{
		switch (event)
		{
			case EVENT_ACTIVATE:
				m_bPaintRequired = true;
			break;

			case EVENT_DEACTIVATE:
			break;
		}
		return TRUE;
	}
};

PLUGIN_EXPORT(TBuilderPlugin);
//---------------------------------------------------------------------------
